"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FetchPlugin = void 0;
require("isomorphic-unfetch");
exports.FetchPlugin = {
    unref: async ({ href, method = "get", headers = {} }) => {
        const response = await fetch(href, {
            method,
            headers,
        });
        if (response.status >= 400) {
            throw response.statusText;
        }
        return await response.json();
    },
    parse: (params) => {
        if (typeof params !== "object" || params === null) {
            throw new TypeError();
        }
        const { href, method, headers } = params;
        if (typeof href !== "string") {
            throw new TypeError();
        }
        if (method && typeof method !== "string") {
            throw new TypeError();
        }
        if (headers) {
            if (typeof headers !== "object" || headers === null) {
                throw new TypeError();
            }
            if (Object.entries(headers).some(([key, value]) => typeof key !== "string" && typeof value !== "string")) {
                throw new TypeError();
            }
        }
        return { href, method, headers };
    },
};
//# sourceMappingURL=FetchPlugin.js.map